#pragma once

#include "Actor.h"
#include "Manager.h"
#include "Observer.h"


class CMainActor : public CActor
{
public:
	CMainActor(void);
	virtual ~CMainActor(void);

	// Registeration
public:
	void RegisterActor(CActor *pOb);
	void UnRegisterActor(CActor *pOb);

	void RegisterManager(CManager *pOb);
	void UnRegisterManager(CManager *pOb);
	
	// Notification
public:
	void NotifyActorDeletion(CActor *pActor);
	void NotifyMangerDeletion(CManager *pManager);


private:
	CGTObserved<CActor> m_listObserver_Actor;
	CGTObserved<CManager> m_listObserver_Manager;
};
